/**********************************************************************
 * AVMI.C       Copyright (C) University of Lincs and Humberside 1999 *
 *--------------------------------------------------------------------*
 * Virtual Machine - Hex input                                        *
 *--------------------------------------------------------------------*
 * Version: 1.00;  Author: Damian G Walker;  Date: 19-Feb-1999        *
 **********************************************************************/

#define _HEXLOAD_C_

/* included headers ***************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* global variables ***************************************************/

static int quiet; /* !0 means no prompting */

/* level 1 routines ***************************************************/

/* create a single file */
static int createfile(char *filename) {
  FILE *outputfile; /* file to output */
  char buf[128], /* input buffer */
    *ptr; /* pointer to input buffer */
  unsigned int org,
    byte; /* origin address */
  if(!( outputfile = fopen(filename, "wb") )) return 1;
  if(!quiet) puts(filename);
  do {
    if(!quiet) printf("???:");
    gets(buf);
  } while( sscanf(buf, "%x", &org) != 1 );
  fputc(org >> 4, outputfile);
  do {
    if(!quiet) printf("%03x:", org);
    gets(buf);
    if( strlen(buf) == 0 || strlen(buf) % 2 ) break;
    for(ptr = buf; *ptr; ptr += 2) {
      sscanf(ptr, "%2x", &byte);
      fputc(byte, outputfile);
      ++org;
    }
  } while(1);
  fclose(outputfile);
  return 0;
}

/* level 0 routines ***************************************************/

int main(int argc, char **argv) {
  int argn; /* count through arguments */
  quiet = 0;
  if(argc < 2)
    puts("usage: avmi FILE [FILE...]");
  for(argn = 1; argn < argc; ++argn) {
    if( !strcmp(argv[argn], "-q") || !strcmp(argv[argn], "--quiet") )
      quiet = !0;
    else if(createfile( argv[argn] ))
      return 1;
  }
  return argc > 1 ? 0 : 1;
}
